/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "common.h"

jpacket jpacket_new(xmlnode x)
{
    jpacket p;

    p = pmalloc(xmlnode_pool(x),sizeof(_jpacket));
    p->x = x;
    p->p = xmlnode_pool(x);
    p->to = p->from = NULL;
    p->flag = 0;
    p->type = JPACKET_UNKNOWN;

    if(j_strcmp(xmlnode_get_name(x),"message") == 0)
        p->type = JPACKET_MESSAGE;
    if(j_strcmp(xmlnode_get_name(x),"presence") == 0)
        p->type = JPACKET_PRESENCE;
    if(j_strcmp(xmlnode_get_name(x),"iq") == 0)
        p->type = JPACKET_IQ;

    if(xmlnode_get_attrib(x,"to") != NULL)
        p->to = jid_new(p->p, xmlnode_get_attrib(x,"to"));
    if(xmlnode_get_attrib(x,"from") != NULL)
        p->from = jid_new(p->p, xmlnode_get_attrib(x,"from"));

    return p;
}


