/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include <config.h>

#ifndef INCL_LOG_H
#define INCL_LOG_H

#define JLIB_LOG_NONE	0
#define JLIB_LOG_STDERR	1
#define JLIB_LOG_FILE	2
#define JLIB_LOG_SYSLOG	3

#define LOGSIZE_HDR  1024 + 1
#define LOGSIZE_TAIL 2048 + 1

#define ZONE zonestr(__FILE__,__LINE__)

extern int jlib_log_device;
extern thread jlib_log_device_file;

void _jdebug(char *zone, const char *msgfmt, ...);
void _log(const char *logmsg);
void jwarn(char *zone, const char *msgfmt, ...);
void jerror(char *zone, const char *msgfmt, ...);
char *create_log_timestamp(void);
char *zonestr(char *file, int line);

#endif
