/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#ifndef INCL_TLISTEN_H
#define INCL_TLISTEN_H

extern int jlib_tlisten_default;

typedef void (*tlisten_onConnect)(thread t, int sock, struct sockaddr_in sa);

typedef struct tlisten
{
     int                         s;	/* Base accept/server socket */
     tlisten_onConnect connect_evt;	/* Function pointer for onConnect event */
     void        *connect_evt_data;	/* Used by onConnect event */
     char                      *ip;
     u_short                  port;
} _tlisten, *tlisten;

/* Creates the tlisten stuct, socket, and thread to accept connects */
thread tlisten_new(u_short port, char *ip, tlisten_onConnect evt, void *evt_data);

/* This is the main loop for the tlisten thread */
void *_tlisten_main(void *arg);

/* Called when the thread exits to clean up any tlisten data and free the tlisten struct */
void _tlisten_cleanup(void *arg);

#endif
