/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#ifndef INCL_XMLSTREAM_H
#define INCL_XMLSTREAM_H

#define XMLSTREAM_ERROR -1
#define XMLSTREAM_ROOT 0
#define XMLSTREAM_NODE 1
#define XMLSTREAM_CLOSE 2
#define XMLSTREAM_INIT 3
#define XMLSTREAM_BOUNCE 4

#define XML_MAX_DEPTH 100

typedef int (*xmlstream_onNode)(thread t, xmlnode x, int type);

/* Wrapper around tstream_* */
thread xmlstream_new(int fd, char *host, xmlstream_onNode evt);
thread xmlstream_connect(int port, char *host, xmlstream_onNode evt);

/* Specifies a new xmlnode to serialize to the fd */
int xmlstream_write(thread t, xmlnode x);

/* Special utilities */
xmlnode xmlstream_header(char *namespace, char *to, char *from);
void xmlstream_write_header(thread t, xmlnode x);
void xmlstream_error(thread t, char *err);

/* The onRead callback for the tstream */
void _xmlstream_main(thread t, void *buffer, int bufsz);
void _xmlstream_error(thread t, tstream_buffer buffer);

void _xmlstream_cleanup(void *arg);

#endif

