/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include <jabber/jlib.h>

unsigned int jlib_stack_default = 16*1024;
int jlib_debug_flag = 0;

int jlib_init(int log2, char *arg)
{
    int fd = 0;

    /* EPIPE is easier to handle than a signal */
    signal(SIGPIPE, SIG_IGN);

    /* init pth */
    pth_init();	

    if(jlib_debug_flag)
        log2 = JLIB_LOG_STDERR;

    switch(log2)
    {
        case JLIB_LOG_FILE:
            fd = open(arg, O_WRONLY | O_CREAT | O_APPEND, 0600);
            if(fd > 0)
                jlib_log_device_file = tstream_new(fd, "_log", NULL, NULL, NULL);
            else
                log2 = JLIB_LOG_STDERR;
            break;
        case JLIB_LOG_SYSLOG:
            if(arg == NULL)
                openlog("jabber", LOG_PID, LOG_DAEMON);
            else
                openlog(arg, LOG_PID, LOG_DAEMON);
            break;
    }
    jlib_log_device = log2;

    jdebug(ZONE,"jlib_init");

    return 1;
}

void jlib_debug()
{
    jlib_debug_flag = 1;
    jlib_log_device = JLIB_LOG_STDERR;
}
